#ifndef _XCONIO_H
#define _XCONIO_H  1

#if !defined(_WIN32) && !defined(__WIN32__)                                    \
    && !defined(__MINGW32__) /* POSIX env */
#    include <termios.h>
#    include <unistd.h>

#else /* Win32 env */
#    include <windows.h>
#    include <conio.h>

#    if defined(_MSC_VER)
#        include "xconio/msvc/unistd.h"
/* To circumvent `warning C4996` about using the (deprecated ?) POSIX name */
#        define getch() _getch()
#    else
/* MinGW or some other POSIX env for Win32 */
#        include <unistd.h>
#    endif

#endif

#ifdef __cplusplus
extern "C" {
#endif

void clrscr(void);
void gotoxy(short x, short y);

#if !defined(_WIN32) && !defined(__WIN32__) && !defined(__MINGW32__)
int getch(void);
#endif

short getkey(void);
void flushnl(void);

#ifdef __cplusplus
}
#endif

#endif /* _XCONIO_H */
