#include "puzzle.h"

static inline void print_numbers(short x, short y, short cntr,
                                 const unsigned short *pNumbers)
{
  short i = 0;
  
  for (i = cntr; i < COLS + cntr; i++) {
    if (*(pNumbers + i) == 0)
      printf(EMPTY_TILE_FMT, 0);
    else {
      putchar('|');
      scrSetColors(scrCyan, scrBlack);
      printf(FILLED_TILE_FMT, *(pNumbers + i));
      scrSetColors(scrMagenta, scrBlack);
    }
  }
  
  gotoxy(x, y);
}

void Board(const unsigned short *pNumbers)
{
  unsigned short row_cntr, how_high, strtingPt, spaces;
  short x = MARGIN, y = 0, cntr = 0, i;
  
  clrscr();
  scrSetColors(scrMagenta, scrBlack);

  TOP_ROW(x, y)

  for (how_high = 0; how_high < ROW_HEIGHT; how_high++)
    VERT(x, y++)

  for (row_cntr = 0; row_cntr < ROWS; row_cntr++) {
    HOR(x, y++)

    for (how_high = 0; how_high < ROW_HEIGHT; how_high++)
      VERT(x, y++)
  }

  BTM_ROW(x, y)

  strtingPt = (ROW_HEIGHT / 2 + 2);
  spaces = (ROW_HEIGHT + 1);
  gotoxy(x, strtingPt);

  for (row_cntr = 0; row_cntr < COLS; row_cntr++) {
    print_numbers(x, (strtingPt += spaces), cntr, pNumbers);
    cntr += COLS;
  }
  
  cntr = 0;
  scrSetColors(scrGreen, scrBlack);
  gotoxy(10, y += 2);
  printf("Arrange the numbers from smallest to greatest\n");
  gotoxy(8, y += 2);
  
  for (i = 0; i < 49; i++)
    putchar('.');
    
  putchar('\n');
  
#if !defined(_WIN32)
  gotoxy(10, y += 2);
#else
  gotoxy(9, y += 2); /* yet another vagary of DOS console output!*/
#endif

  printf("Move tiles: left...< arrow | Solve");
  printf(".....S\n");
  printf("%50s", "right...> arrow | New Game..R\n");
  printf("%42s", "up...^ arrow | Quit");
  printf("......Q\n");
  printf("%35s", "down...v arrow");
  gotoxy(10, y += 6);
  printf(">>> ");
}
