/** @remarks For the trick of checking and array of randomly generated numbers
 * against an array of the same size, with the aim of avoiding duplicates, I am
 * grateful to Dan Gookin's 'C All-One-Desk-Reference for Dummies',
 * (Indianapolis: Wiley,2004), pp. 505-6 */
#include <stdio.h>
#include <stdlib.h>
#include <time.h>

unsigned short *GetNumbers(unsigned short *numbers)
{
  short i, tile, chosen[16] = {0};

  srand((unsigned)time(NULL));

  for (i = 0; i < 15; i++) {
    do {
      tile = (rand() % 15) + 1;
    } while (chosen[tile]); /*tests TRUE if random # has already been assigned*/

    chosen[tile] = 1; /* the num just assigned --- can't be used again */
    numbers[i] = tile;
  }

  numbers[15] = 0;

  return numbers;
}
