#ifndef PUZZLE_H
#define PUZZLE_H 1

#include <stdio.h>
#include "xconio.h"
#include "xconio/console/scrutil.h"

#define WIDTH (COLS * 8)
/* b/c cols are set by a tab, and 8 spcs is the apparent width of a tab in the
 * console window */
#define MARGIN 16
/* the starting pos of 'x'; must be a divisibe by 8, for the above-noted resason
 */
#define ROWS (COLS - 1)
#define COLS 4
/* odd values of ROW_HEIGHT yield the most  attractive results */
#define ROW_HEIGHT 3
#define CUR_POS(x) (16 - 4 * x)
#define ADJ_POS(x) (15 - 4 * x)

#if !defined(_WIN32) && !defined(__WIN32__) && !defined(__MINGW32__)
/* implement POSIX-compatable alternatives for the char encoding, etc.,
 * which are essential for the display and interaction fn's; details
 * below and in the 'my.conio' header */
#define EMPTY_TILE_FMT "|%4c\t\b"
#define FILLED_TILE_FMT "%4hd\t\b"
#define TOP_ROW(x, y)                                                          \
    {                                                                          \
        gotoxy(x, y + 1);                                                      \
        printf("%c", 43);                                                      \
        for (i = 0; i < WIDTH - 1; i++)                                        \
            printf("%c", 45);                                                  \
        printf("%c", 43);                                                      \
        y += 2;                                                                \
    }
#define HOR(x, y)                                                              \
    {                                                                          \
        gotoxy(x, y);                                                          \
        printf("%c", 124);                                                     \
        for (i = 0; i < WIDTH - 1; i++)                                        \
            printf("%c", 45);                                                  \
        printf("%c", 124);                                                     \
    }
#define VERT(x, y)                                                             \
    {                                                                          \
        gotoxy(x, y);                                                          \
        for (i = 0; i < COLS + 1; i++)                                         \
            printf("%c\t\b", 124);                                             \
    }
#define BTM_ROW(x, y)                                                          \
    {                                                                          \
        gotoxy(x, y);                                                          \
        printf("%c", 43);                                                      \
        for (i = 0; i < WIDTH - 1; i++)                                        \
            printf("%c", 45);                                                  \
        printf("%c", 43);                                                      \
    }

#else /* Windows environment */
#define EMPTY_TILE_FMT "|%4c\t"
#define FILLED_TILE_FMT "%4hd\t"
#define TOP_ROW(x, y)                                                          \
    {                                                                          \
        gotoxy(x, y + 1);                                                      \
        printf("%c", 218);                                                     \
        for (i = 0; i < WIDTH - 1; i++)                                        \
            printf("%c", 196);                                                 \
        printf("%c", 191);                                                     \
        y += 2;                                                                \
    }
#define HOR(x, y)                                                              \
    {                                                                          \
        gotoxy(x, y);                                                          \
        printf("%c", 195);                                                     \
        for (i = 0; i < WIDTH - 1; i++)                                        \
            printf("%c", 196);                                                 \
        printf("%c", 180);                                                     \
    }
#define VERT(x, y)                                                             \
    {                                                                          \
        gotoxy(x, y);                                                          \
        for (i = 0; i < COLS + 1; i++)                                         \
            printf("%c\t", 179);                                               \
    }
#define BTM_ROW(x, y)                                                          \
    {                                                                          \
        gotoxy(x, y);                                                          \
        printf("%c", 192);                                                     \
        for (i = 0; i < WIDTH - 1; i++)                                        \
            printf("%c", 196);                                                 \
        printf("%c", 217);                                                     \
    }
#endif

#ifdef __cplusplus
extern "C" {
#endif

typedef enum { REPLAY, NEW_GAME, QUIT } Choice;

void TitleScr(void);
void Board(const unsigned short *);
Choice Play(unsigned short *);
bool Solve(void);
unsigned short *GetNumbers(unsigned short *);

#ifdef __cplusplus
}
#endif

#endif /* PUZZLE_H */
